package omo3;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Objects;

/*
 *   Jednosmerny spojovy seznam
 */

public class LinkedList<E> implements List<E> {

    // atributy tridy
    private Node<E> head;

    // konstruktor
    public LinkedList() {
        head = null;
    }

    // prida prvek na konec seznamu
    public void addValue(E data) {
        if (isEmpty()) {
            head = new Node<>(data);
        } else {
            Node<E> tmp = new Node<>(data);
            Node<E> tmp2 = head;
            while (tmp2.getNext() != null) {
                tmp2 = tmp2.getNext();
            }
            tmp2.setNext(tmp);
        }
    }


    /*
     *   Odstrani prvek ze seznamu na zadanem indexu.
     *   pokud index je mimo vrati false
     */
    public boolean removeFromIndex(int index) {
        return false;
    }

    // Smaze vsechny prvky seznamu
    public void clear() {

    }

    // Vrati pocet prvku v seznamu
    public int size() {
        if (isEmpty()) {
            return 0;
        } else {
            int size = 1;
            Node tmp2 = head;
            while (tmp2.getNext() != null) {
                tmp2 = tmp2.getNext();
                size++;
            }
            return size;
        }
    }

        // TRUE - seznam je prazdny
    // FALSE - jinak
    public boolean isEmpty() {
        return head==null;
    }

    /*
     *   Vypise obsah seznamu v nasledujicim formatu
     *   - LIST[N] = {hodnota1, hodnota2, ... hodnotaN}, kde N je pocet prvku seznamu
     */
    @Override
    public String toString() {
        return null;
    }

    // Vrati data ulozena v Node na zadanem indexu
    // - indexujeme od 0
    public E getData(int index) {
        if (index<0){throw new IndexOutOfBoundsException();}
        int counter = 0;
        if(this.isEmpty()) {throw new IndexOutOfBoundsException();};
        Node<E> temp = head;
        while(counter != index){
          
            temp = temp.getNext();
            if(temp==null){throw new IndexOutOfBoundsException();}
            counter++;
        }
        return temp.getData();
    }

    // Zmeni data na indexu
    // - pokud Node s indexem neexistuje vraci FALSE
    // - jina TRUE
    public boolean setData(int index, E data) {
        return false;
    }

    /*  
     *   Obsahuje seznam hodnotu urcenou parametrem ?
     *   TRUE - obsahuje
     *   FALSE - neobsahuje
     */
    @Override
    public boolean contains(Object data) {
        
        if(this.isEmpty())
            return false;
        Node tmp2 = head;
            while (tmp2 !=null) {
                if(Objects.equals(tmp2.getData(), data)){
                     return true;
                }
                tmp2=tmp2.getNext();
            }
        
        return false;
    }

    /*
     *   Vlozi novy prvek na pozici urcenou indexm
     *    - vraci FALSE pokud je index mimo rozsah  (index < 0 || index > size())
     *    - jinak TRUE
     * 
     *   poz.: Metoda musi prvek pridat, nikoliv prepsat
     */
    public boolean insert(int index, E data) {
        return false;
    }


    @Override
    public Iterator<E> iterator() {
        return new NodeListIterator<>(this.head);
    }

    @Override
    public Object[] toArray() {
        Object[] arr = new Object[this.size()];
        int i = 0;
        for(Object o : this) {
            arr[i] = o;
            i++;
        }
        return arr;
    }

    @Override
    public <T> T[] toArray(T[] a) {
        if(a.length <= this.size()) {
            int i = 0;
            for(Object o : this) {
                a[i] = (T)o;
                i++;
            }
            return a;
        }
        else {
            return (T[]) this.toArray();
        }
    }

    @Override
    public boolean add(E e) {
        this.addValue(e);
        return true;
    }

    @Override
    public boolean remove(Object o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean containsAll(Collection<?> c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean addAll(Collection<? extends E> c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean addAll(int index, Collection<? extends E> c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean removeAll(Collection<?> c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public boolean retainAll(Collection<?> c) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public E get(int index) {
        return this.getData(index);
    }

    @Override
    public E set(int index, E element) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void add(int index, E element) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public E remove(int index) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int indexOf(Object o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int lastIndexOf(Object o) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public ListIterator<E> listIterator() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public ListIterator<E> listIterator(int index) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public List<E> subList(int fromIndex, int toIndex) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

}
